﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Planemovement : MonoBehaviour
{
    //bool toggle = true;
    int cnt = 0;
    double beta = 0.5f; // v/c
    Vector3 alpha = new Vector3(0.1f, 0.0f, 0.0f); // proper acceleration
    Vector3 v;
    // Start is called before the first frame update

    public GameObject theobject;


    void Start()
    {
        Renderer r = theobject.GetComponent<Renderer>();
        //Color materialColor = r.material.color;
        r.material.color = Color.blue;
        v = new Vector3(0.0f, 0.0f, 0.0f);
    }

    // Update is called once per frame

    // For physics calcs
    void FixedUpdate()
    {
        var prevup = transform.up;
        var prevfor = transform.forward;
        transform.Translate(Vector3.up * Time.fixedDeltaTime, Space.World); // move up by 1 second
        cnt++;
        if (cnt % 480 == 0)
        {
            cnt = 0;
        }
        //transform.Translate(Vector3.forward * Time.fixedDeltaTime, Space.World);
        //transform.Translate(0.5f*Vector3.forward * Mathf.Cos(2*Mathf.PI*cnt/480) * Time.fixedDeltaTime, Space.World);
        //transform.Translate(0.5f*Vector3.left * Mathf.Sin(2 * Mathf.PI * cnt / 480) * Time.fixedDeltaTime, Space.World);

        //var v = (float)beta * Vector3.forward * Mathf.Cos(2 * Mathf.PI * cnt / 480) + (float)beta * Vector3.left * Mathf.Sin(2 * Mathf.PI * cnt / 480);
        
        v = alpha.normalized * (alpha.magnitude * Time.time / Mathf.Sqrt(1.0f+(alpha.magnitude * Time.time)*(alpha.magnitude * Time.time)));

        Debug.Log(v.ToString("F6"));

        beta = v.magnitude / 1.0f;

        double gamma = 1.0f / Mathf.Sqrt(1.0f - (float)(beta*beta));

        transform.Translate(v * Time.fixedDeltaTime, Space.World);

        var vt = v + Vector3.up;

        vt.x = -vt.x;

        vt.z = -vt.z;

        vt.Normalize();

        //transform.up = vt;
        //theobject.transform.up = vt;

        //Quaternion rotation = Quaternion.LookRotation(Vector3.forward, vt);
        //transform.rotation = rotation;

        transform.localScale = new Vector3(1.0f, 1.0f, 1.0f); // release child to change x'-axis scale
        theobject.transform.up = vt;

        theobject.transform.parent = null;

        Vector3 newforward = new Vector3(vt.y * (v.x/v.magnitude),Mathf.Sqrt(vt.x * vt.x + vt.z *vt.z), vt.y * (v.z / v.magnitude));

        transform.rotation = Quaternion.LookRotation(newforward, vt);

        //Quaternion forwardrotation = Quaternion.FromToRotation(prevfor, newforward);

        //transform.forward = newforward;

        theobject.transform.parent = transform;

        transform.localScale = new Vector3(1.0f, 1.0f, (float)gamma); // scale x' axis

    }
}
